Attribute VB_Name = "modSubclassDLL"
' modSubclassDLL.bas  -    
'     (The trick), 2014

Option Explicit

'          
Public Type MsgData
    hWnd    As Long     '   
    uMsg    As Long     ' 
    wParam  As Long     ' 
    lParam  As Long     ' -
    return  As Long     '  
    defCall As Long     '    
End Type

Private Declare Function OpenFileMapping Lib "kernel32" Alias "OpenFileMappingW" (ByVal dwDesiredAccess As Long, ByVal bInheritHandle As Long, ByVal lpName As Long) As Long
Private Declare Function OpenMutex Lib "kernel32" Alias "OpenMutexW" (ByVal dwDesiredAccess As Long, ByVal bInheritHandle As Long, ByVal lpName As Long) As Long
Private Declare Function MapViewOfFile Lib "kernel32" (ByVal hFileMappingObject As Long, ByVal dwDesiredAccess As Long, ByVal dwFileOffsetHigh As Long, ByVal dwFileOffsetLow As Long, ByVal dwNumberOfBytesToMap As Long) As Long
Private Declare Function UnmapViewOfFile Lib "kernel32" (ByVal lpBaseAddress As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function GetMem4 Lib "msvbvm60" (Src As Any, Dst As Any) As Long
Private Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long
Private Declare Function ReleaseMutex Lib "kernel32" (ByVal hMutex As Long) As Long
Private Declare Function CallNextHookEx Lib "user32" (ByVal hHook As Long, ByVal ncode As Long, ByVal wParam As Integer, lParam As Any) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageW" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongW" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function SetProp Lib "user32" Alias "SetPropW" (ByVal hWnd As Long, ByVal lpString As Long, ByVal hData As Long) As Long
Private Declare Function RemoveProp Lib "user32" Alias "RemovePropW" (ByVal hWnd As Long, ByVal lpString As Long) As Long
Private Declare Function GetProp Lib "user32" Alias "GetPropW" (ByVal hWnd As Long, ByVal lpString As Long) As Long
Private Declare Function GlobalAddAtom Lib "kernel32" Alias "GlobalAddAtomW" (ByVal lpString As Long) As Integer
Private Declare Function GlobalDeleteAtom Lib "kernel32" (ByVal nAtom As Integer) As Integer
Private Declare Function RegisterWindowMessage Lib "user32" Alias "RegisterWindowMessageW" (ByVal lpString As Long) As Long
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcW" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Private Const GWL_WNDPROC        As Long = (-4)
Private Const INFINITE           As Long = -1&
Private Const MUTEX_ALL_ACCESS   As Long = &H1F0001
Private Const FILE_MAP_READ      As Long = &H4
Private Const FILE_MAP_WRITE     As Long = &H2
Private Const WAIT_FAILED        As Long = -1&

Private WM_SENDMESSAGE   As Long    '       .      
                                    '    (TestSubclassDLL),     SendMessage  , 
                                    '   ,      .  
                                    '  (TestSubclassDLL)    ,    ,  
                                    '     .
    
Dim hMutex      As Long     '     /  
Dim hMap        As Long     '   
Dim lpShrdData  As Long     '   
Dim hWndServer  As Long     '       
Dim hWndHook    As Long     '      
Dim hHook       As Long     '  ,    CallNextHookEx
Dim aPrevProc   As Integer  '      
Dim init        As Boolean  '   
Dim disabled    As Boolean  '  .

' //  
Public Function GetMsgProc(ByVal code As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Dim prevProc    As Long
    '     - 
    If Not (init Or disabled) Then
        '  
        hMap = OpenFileMapping(FILE_MAP_WRITE, False, StrPtr("TrickSubclassFileMap"))
        If hMap = 0 Then MsgBox "  ", vbCritical: Clear: Exit Function
        ' 
        lpShrdData = MapViewOfFile(hMap, FILE_MAP_WRITE, 0, 0, 0)
        CloseHandle hMap: hMap = 0
        If lpShrdData = 0 Then MsgBox "  ", vbCritical: Clear: Exit Function
        '   
        hMutex = OpenMutex(MUTEX_ALL_ACCESS, False, StrPtr("TrickSubclassMutex"))
        If hMutex = 0 Then MsgBox "  ", vbCritical: Clear: Exit Function
        '  
        WM_SENDMESSAGE = RegisterWindowMessage(StrPtr(WM_SENDMESSAGE))
        If WM_SENDMESSAGE = 0 Then MsgBox "  ", vbCritical: Clear: Exit Function
        ' /      
        aPrevProc = GlobalAddAtom(StrPtr("prevProc"))
        If aPrevProc = 0 Then MsgBox "  ", vbCritical: Clear: Exit Function
        '  .           SetWindowsHookEx, 
        '    ,  ..       ,      
        '   ,             
        If WaitForSingleObject(hMutex, INFINITE) = WAIT_FAILED Then MsgBox " ", vbCritical: Clear: Exit Function
        '   ,    
        GetMem4 ByVal lpShrdData, hWndServer
        '    
        GetMem4 ByVal lpShrdData + 4, hWndHook
        '   
        GetMem4 ByVal lpShrdData + 8, hHook
        '  
        ReleaseMutex hMutex
        '       
        prevProc = SetWindowLong(hWndHook, GWL_WNDPROC, AddressOf WndProc)
        If prevProc = 0 Then MsgBox "   ", vbCritical: Clear: Exit Function
        '   
        SetProp hWndHook, CLng(aPrevProc) And &HFFFF&, prevProc
        ' 
        init = True
    End If
    '     
    GetMsgProc = CallNextHookEx(hHook, code, wParam, lParam)
End Function

' // 
Public Sub Clear()
    If hMutex Then CloseHandle (hMutex): hMutex = 0
    If lpShrdData Then UnmapViewOfFile (lpShrdData): lpShrdData = 0
    If hWndHook Then RemoveProp hWndHook, CLng(aPrevProc) And &HFFFF&: hWndHook = 0
    If aPrevProc Then GlobalDeleteAtom (aPrevProc): aPrevProc = 0
    init = False
End Sub

' //  
Private Function WndProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Dim sendData    As MsgData
    Dim prevProc    As Long
    '     
    If uMsg = WM_SENDMESSAGE Then
        '    
        prevProc = GetProp(hWnd, CLng(aPrevProc) And &HFFFF&)
        '    
        SetWindowLong hWnd, GWL_WNDPROC, prevProc
        ' 
        Clear
        '  
        '      GetMsgProc,  ,       
        '      .
        disabled = True
        Exit Function
        '       UnhookWindowsHookEx   DLL    .
    End If
    '  
    sendData.hWnd = hWnd
    sendData.uMsg = uMsg
    sendData.wParam = wParam
    sendData.lParam = lParam
    sendData.defCall = True
    '  
    If WaitForSingleObject(hMutex, INFINITE) = WAIT_FAILED Then MsgBox " ", vbCritical: Clear: Exit Function
    CopyMemory ByVal lpShrdData + 12, sendData, Len(sendData)
    '  
    ReleaseMutex hMutex
    '    
    SendMessage hWndServer, WM_SENDMESSAGE, 0, ByVal 0
    '   
    If WaitForSingleObject(hMutex, INFINITE) = WAIT_FAILED Then MsgBox " ", vbCritical: Clear: Exit Function
    CopyMemory sendData, ByVal lpShrdData + 12, Len(sendData)
    '  
    ReleaseMutex hMutex
    '     
    If sendData.defCall Then
        prevProc = GetProp(hWnd, CLng(aPrevProc) And &HFFFF&)
        WndProc = CallWindowProc(prevProc, sendData.hWnd, sendData.uMsg, sendData.wParam, sendData.lParam)
    Else
        WndProc = sendData.return
    End If
End Function
