Attribute VB_Name = "modMain"
' modMain.bas -     NativeDLL    DLL   
'     (The trick), 2014

Option Explicit

'   SubclassDLL
Public Type MsgData
    hwnd    As Long
    uMsg    As Long
    wParam  As Long
    lParam  As Long
    return  As Long
    defCall As Long
End Type

Public Type POINTAPI
    x   As Long
    y   As Long
End Type
Public Type MINMAXINFO
    ptReserved      As POINTAPI
    ptMaxSize       As POINTAPI
    ptMaxPosition   As POINTAPI
    ptMinTrackSize  As POINTAPI
    ptMaxTrackSize  As POINTAPI
End Type
Public Type RECT
    Left    As Long
    Top     As Long
    Right   As Long
    Bottom  As Long
End Type

Public Declare Function OffsetRect Lib "user32" (lpRect As RECT, ByVal x As Long, ByVal y As Long) As Long
Public Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Public Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hdc As Long) As Long
Public Declare Function GetWindowRgn Lib "user32" (ByVal hwnd As Long, ByVal hRgn As Long) As Long
Public Declare Function CreateRectRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Public Declare Function FrameRgn Lib "gdi32" (ByVal hdc As Long, ByVal hRgn As Long, ByVal hBrush As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Public Declare Function FrameRect Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Public Declare Function GetWindowDC Lib "user32" (ByVal hwnd As Long) As Long
Public Declare Function GetStockObject Lib "gdi32" (ByVal nIndex As Long) As Long
Public Declare Function SetROP2 Lib "gdi32" (ByVal hdc As Long, ByVal nDrawMode As Long) As Long
Public Declare Function GetROP2 Lib "gdi32" (ByVal hdc As Long) As Long
Public Declare Function WriteProcessMemory Lib "kernel32" (ByVal hProcess As Long, lpBaseAddress As Any, lpBuffer As Any, ByVal nSize As Long, lpNumberOfBytesWritten As Long) As Long
Public Declare Function ReadProcessMemory Lib "kernel32" (ByVal hProcess As Long, lpBaseAddress As Any, lpBuffer As Any, ByVal nSize As Long, lpNumberOfBytesWritten As Long) As Long
Public Declare Function WindowFromPoint Lib "user32" (ByVal xPoint As Long, ByVal yPoint As Long) As Long
Public Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Public Declare Function OpenProcess Lib "kernel32" (ByVal dwDesiredAccess As Long, ByVal bInheritHandle As Long, ByVal dwProcessId As Long) As Long
Public Declare Function CreateFileMapping Lib "kernel32" Alias "CreateFileMappingW" (ByVal hFile As Long, lpFileMappigAttributes As Any, ByVal flProtect As Long, ByVal dwMaximumSizeHigh As Long, ByVal dwMaximumSizeLow As Long, ByVal lpName As Long) As Long
Public Declare Function MapViewOfFile Lib "kernel32" (ByVal hFileMappingObject As Long, ByVal dwDesiredAccess As Long, ByVal dwFileOffsetHigh As Long, ByVal dwFileOffsetLow As Long, ByVal dwNumberOfBytesToMap As Long) As Long
Public Declare Function UnmapViewOfFile Lib "kernel32" (ByVal lpBaseAddress As Long) As Long
Public Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Public Declare Function CreateMutex Lib "kernel32" Alias "CreateMutexW" (lpMutexAttributes As Any, ByVal bInitialOwner As Long, ByVal lpName As Long) As Long
Public Declare Function SetWindowsHookEx Lib "user32" Alias "SetWindowsHookExW" (ByVal idHook As Long, ByVal lpfn As Long, ByVal hmod As Long, ByVal dwThreadId As Long) As Long
Public Declare Function UnhookWindowsHookEx Lib "user32" (ByVal hHook As Long) As Long
Public Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryW" (ByVal lpLibFileName As Long) As Long
Public Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long
Public Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Public Declare Function GetMem4 Lib "msvbvm60" (Src As Any, Dst As Any) As Long
Public Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long
Public Declare Function ReleaseMutex Lib "kernel32" (ByVal hMutex As Long) As Long
Public Declare Function GetWindowThreadProcessId Lib "user32" (ByVal hwnd As Long, lpdwProcessId As Long) As Long
Public Declare Function SendMessage Lib "user32" Alias "SendMessageW" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function RegisterWindowMessage Lib "user32" Alias "RegisterWindowMessageW" (ByVal lpString As Long) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongW" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcW" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Public Const GWL_WNDPROC            As Long = (-4)
Public Const ERROR_ALREADY_EXISTS   As Long = 183&
Public Const INVALID_HANDLE_VALUE   As Long = -1
Public Const PAGE_READWRITE         As Long = &H4&
Public Const FILE_MAP_WRITE         As Long = &H2
Public Const INFINITE               As Long = -1&
Public Const WAIT_FAILED            As Long = -1&
Public Const WH_GETMESSAGE          As Long = 3
Public Const PROCESS_VM_OPERATION   As Long = &H8&
Public Const PROCESS_VM_READ        As Long = &H10&
Public Const PROCESS_VM_WRITE       As Long = &H20&
Public Const WM_GETMINMAXINFO       As Long = &H24
Public Const WHITE_BRUSH            As Long = 0
Public Const R2_XORPEN              As Long = 7
Public Const NULLREGION             As Long = 1
Public Const WM_LBUTTONDOWN         As Long = &H201&
Public Const WM_LBUTTONUP           As Long = &H202&

Public WM_SENDMESSAGE   As Long '  
Public hProcess         As Long '  ,    

Dim hMutex      As Long ' ,     
Dim lpShrdData  As Long '    (  )
Dim hLib        As Long '  SubclassDLL
Dim lpProc      As Long '  GetMsgProc
Dim hHook       As Long '  
Dim TID         As Long '  
Dim PID         As Long '  
Dim hMap        As Long '  
Dim lpPrevProc  As Long '     frmMain

' // 
Public Function Initialize() As Boolean
    '    
    hMutex = CreateMutex(ByVal 0&, 0, StrPtr("TrickSubclassMutex"))
    If hMutex = 0 Then MsgBox "  ": Clear: Exit Function
    If Err.LastDllError = ERROR_ALREADY_EXISTS Then MsgBox "   ": Clear: Exit Function
    '  
    hMap = CreateFileMapping(INVALID_HANDLE_VALUE, ByVal 0&, PAGE_READWRITE, 0, 100, StrPtr("TrickSubclassFileMap"))
    If hMap = 0 Then MsgBox "  ": Clear: Exit Function
    ' 
    lpShrdData = MapViewOfFile(hMap, FILE_MAP_WRITE, 0, 0, 0)
    If lpShrdData = 0 Then MsgBox "  ", vbCritical: Clear: Exit Function
    '  
    WM_SENDMESSAGE = RegisterWindowMessage(StrPtr(WM_SENDMESSAGE))
    If WM_SENDMESSAGE = 0 Then MsgBox "  ", vbCritical: Clear: Exit Function
    '      
    lpPrevProc = SetWindowLong(frmMain.hwnd, GWL_WNDPROC, AddressOf WndProc)
    '  DLL
    hLib = LoadLibrary(StrPtr("..\SubclassDLL\SubclassDLL"))
    If hLib = 0 Then MsgBox "  ": ReleaseMutex hMutex: Exit Function
    lpProc = GetProcAddress(hLib, "GetMsgProc")
    If lpProc = 0 Then MsgBox "   GetMsgProc": ReleaseMutex hMutex: Exit Function
    Initialize = True
End Function

' // 
Public Sub Clear()
    If hMap Then CloseHandle (hMap)
    If hMutex Then CloseHandle (hMutex)
    If lpShrdData Then UnmapViewOfFile (lpShrdData)
    If hLib Then FreeLibrary (hLib)
    If lpPrevProc Then SetWindowLong frmMain.hwnd, GWL_WNDPROC, lpPrevProc
    If hProcess Then CloseHandle (hProcess)
End Sub

' //  
Public Function StartSubclass(ByVal hwnd As Long) As Long
    '   
    TID = GetWindowThreadProcessId(hwnd, PID)
    If TID = 0 Then MsgBox "   ": Exit Function
    '    ,    
    If TID = App.ThreadID Then MsgBox "   ": Exit Function
    '   ,  
    StopSubclass hwnd
    '  
    hProcess = OpenProcess(PROCESS_VM_OPERATION Or PROCESS_VM_WRITE Or PROCESS_VM_READ, 0, PID)
    If hProcess = 0 Then MsgBox "  ": Exit Function
    '  
    If WaitForSingleObject(hMutex, INFINITE) = WAIT_FAILED Then MsgBox " ", vbCritical: Clear: Exit Function
    '        
    hHook = SetWindowsHookEx(WH_GETMESSAGE, lpProc, hLib, TID)
    If hHook = 0 Then MsgBox "  ": ReleaseMutex hMutex: Exit Function
    '     
    GetMem4 CLng(frmMain.hwnd), ByVal lpShrdData
    '    
    GetMem4 hwnd, ByVal lpShrdData + 4
    '   
    GetMem4 hHook, ByVal lpShrdData + 8
    '  ,         
    ReleaseMutex hMutex
    StartSubclass = True
End Function

' //  
Public Function StopSubclass(ByVal hwnd As Long) As Long
    If hHook Then
        '    ,          
        SendMessage hwnd, WM_SENDMESSAGE, 0, ByVal 0&
        '  ,     
        UnhookWindowsHookEx (hHook): hHook = 0
        '   
        CloseHandle hProcess: hProcess = 0
        StopSubclass = True
    End If
End Function

' //  
Private Function WndProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Select Case uMsg
    Case WM_SENDMESSAGE
        Dim msg As MsgData
        '  ,     ,      , ..   SendMessage
        '     ,   
        If WaitForSingleObject(hMutex, INFINITE) = WAIT_FAILED Then MsgBox " ", vbCritical: Clear: Exit Function
        '     
        CopyMemory msg, ByVal lpShrdData + 12, Len(msg)
        '   
        msg.return = frmMain.WndProc(msg.hwnd, msg.uMsg, msg.wParam, msg.lParam, msg.defCall)
        '  
        CopyMemory ByVal lpShrdData + 12, msg, Len(msg)
        '  
        ReleaseMutex hMutex
    Case Else
        WndProc = CallWindowProc(lpPrevProc, hwnd, uMsg, wParam, lParam)
    End Select
End Function

' //  
Public Sub SetWMList(msgList() As String)
    ReDim msgList(&H38F)
    msgList(&H0) = "WM_NULL"
    msgList(&H1) = "WM_CREATE"
    msgList(&H2) = "WM_DESTROY"
    msgList(&H3) = "WM_MOVE"
    msgList(&H5) = "WM_SIZE"
    msgList(&H6) = "WM_ACTIVATE"
    msgList(&H7) = "WM_SETFOCUS"
    msgList(&H8) = "WM_KILLFOCUS"
    msgList(&HA) = "WM_ENABLE"
    msgList(&HB) = "WM_SETREDRAW"
    msgList(&HC) = "WM_SETTEXT"
    msgList(&HD) = "WM_GETTEXT"
    msgList(&HE) = "WM_GETTEXTLENGTH"
    msgList(&HF) = "WM_PAINT"
    msgList(&H10) = "WM_CLOSE"
    msgList(&H11) = "WM_QUERYENDSESSION"
    msgList(&H12) = "WM_QUIT"
    msgList(&H13) = "WM_QUERYOPEN"
    msgList(&H14) = "WM_ERASEBKGND"
    msgList(&H15) = "WM_SYSCOLORCHANGE"
    msgList(&H16) = "WM_ENDSESSION"
    msgList(&H18) = "WM_SHOWWINDOW"
    msgList(&H19) = "WM_CTLCOLOR"
    msgList(&H1A) = "WM_WININICHANGE"
    msgList(&H1B) = "WM_DEVMODECHANGE"
    msgList(&H1C) = "WM_ACTIVATEAPP"
    msgList(&H1D) = "WM_FONTCHANGE"
    msgList(&H1E) = "WM_TIMECHANGE"
    msgList(&H1F) = "WM_CANCELMODE"
    msgList(&H20) = "WM_SETCURSOR"
    msgList(&H21) = "WM_MOUSEACTIVATE"
    msgList(&H22) = "WM_CHILDACTIVATE"
    msgList(&H23) = "WM_QUEUESYNC"
    msgList(&H24) = "WM_GETMINMAXINFO"
    msgList(&H26) = "WM_PAINTICON"
    msgList(&H27) = "WM_ICONERASEBKGND"
    msgList(&H28) = "WM_NEXTDLGCTL"
    msgList(&H2A) = "WM_SPOOLERSTATUS"
    msgList(&H2B) = "WM_DRAWITEM"
    msgList(&H2C) = "WM_MEASUREITEM"
    msgList(&H2D) = "WM_DELETEITEM"
    msgList(&H2E) = "WM_VKEYTOITEM"
    msgList(&H2F) = "WM_CHARTOITEM"
    msgList(&H30) = "WM_SETFONT"
    msgList(&H31) = "WM_GETFONT"
    msgList(&H32) = "WM_SETHOTKEY"
    msgList(&H33) = "WM_GETHOTKEY"
    msgList(&H37) = "WM_QUERYDRAGICON"
    msgList(&H39) = "WM_COMPAREITEM"
    msgList(&H3D) = "WM_GETOBJECT"
    msgList(&H41) = "WM_COMPACTING"
    msgList(&H44) = "WM_COMMNOTIFY"
    msgList(&H46) = "WM_WINDOWPOSCHANGING"
    msgList(&H47) = "WM_WINDOWPOSCHANGED"
    msgList(&H48) = "WM_POWER"
    msgList(&H49) = "WM_COPYGLOBALDATA"
    msgList(&H4A) = "WM_COPYDATA"
    msgList(&H4B) = "WM_CANCELJOURNAL"
    msgList(&H4E) = "WM_NOTIFY"
    msgList(&H50) = "WM_INPUTLANGCHANGEREQUEST"
    msgList(&H51) = "WM_INPUTLANGCHANGE"
    msgList(&H52) = "WM_TCARD"
    msgList(&H53) = "WM_HELP"
    msgList(&H54) = "WM_USERCHANGED"
    msgList(&H55) = "WM_NOTIFYFORMAT"
    msgList(&H7B) = "WM_CONTEXTMENU"
    msgList(&H7C) = "WM_STYLECHANGING"
    msgList(&H7D) = "WM_STYLECHANGED"
    msgList(&H7E) = "WM_DISPLAYCHANGE"
    msgList(&H7F) = "WM_GETICON"
    msgList(&H80) = "WM_SETICON"
    msgList(&H81) = "WM_NCCREATE"
    msgList(&H82) = "WM_NCDESTROY"
    msgList(&H83) = "WM_NCCALCSIZE"
    msgList(&H84) = "WM_NCHITTEST"
    msgList(&H85) = "WM_NCPAINT"
    msgList(&H86) = "WM_NCACTIVATE"
    msgList(&H87) = "WM_GETDLGCODE"
    msgList(&H88) = "WM_SYNCPAINT"
    msgList(&HA0) = "WM_NCMOUSEMOVE"
    msgList(&HA1) = "WM_NCLBUTTONDOWN"
    msgList(&HA2) = "WM_NCLBUTTONUP"
    msgList(&HA3) = "WM_NCLBUTTONDBLCLK"
    msgList(&HA4) = "WM_NCRBUTTONDOWN"
    msgList(&HA5) = "WM_NCRBUTTONUP"
    msgList(&HA6) = "WM_NCRBUTTONDBLCLK"
    msgList(&HA7) = "WM_NCMBUTTONDOWN"
    msgList(&HA8) = "WM_NCMBUTTONUP"
    msgList(&HA9) = "WM_NCMBUTTONDBLCLK"
    msgList(&HAB) = "WM_NCXBUTTONDOWN"
    msgList(&HAC) = "WM_NCXBUTTONUP"
    msgList(&HAD) = "WM_NCXBUTTONDBLCLK"
    msgList(&HE0) = "SBM_SETPOS"
    msgList(&HE1) = "SBM_GETPOS"
    msgList(&HE2) = "SBM_SETRANGE"
    msgList(&HE3) = "SBM_GETRANGE"
    msgList(&HE4) = "SBM_ENABLE_ARROWS"
    msgList(&HE6) = "SBM_SETRANGEREDRAW"
    msgList(&HE9) = "SBM_SETSCROLLINFO"
    msgList(&HEA) = "SBM_GETSCROLLINFO"
    msgList(&HEB) = "SBM_GETSCROLLBARINFO"
    msgList(&HFF) = "WM_INPUT"
    msgList(&H100) = "WM_KEYDOWN"
    msgList(&H101) = "WM_KEYUP"
    msgList(&H102) = "WM_CHAR"
    msgList(&H103) = "WM_DEADCHAR"
    msgList(&H104) = "WM_SYSKEYDOWN"
    msgList(&H105) = "WM_SYSKEYUP"
    msgList(&H106) = "WM_SYSCHAR"
    msgList(&H107) = "WM_SYSDEADCHAR"
    msgList(&H108) = "WM_KEYLAST"
    msgList(&H109) = "WM_WNT_CONVERTREQUESTEX"
    msgList(&H10A) = "WM_CONVERTREQUEST"
    msgList(&H10B) = "WM_CONVERTRESULT"
    msgList(&H10C) = "WM_INTERIM"
    msgList(&H10D) = "WM_IME_STARTCOMPOSITION"
    msgList(&H10E) = "WM_IME_ENDCOMPOSITION"
    msgList(&H10F) = "WM_IME_COMPOSITION"
    msgList(&H110) = "WM_INITDIALOG"
    msgList(&H111) = "WM_COMMAND"
    msgList(&H112) = "WM_SYSCOMMAND"
    msgList(&H113) = "WM_TIMER"
    msgList(&H114) = "WM_HSCROLL"
    msgList(&H115) = "WM_VSCROLL"
    msgList(&H116) = "WM_INITMENU"
    msgList(&H117) = "WM_INITMENUPOPUP"
    msgList(&H118) = "WM_SYSTIMER"
    msgList(&H11F) = "WM_MENUSELECT"
    msgList(&H120) = "WM_MENUCHAR"
    msgList(&H121) = "WM_ENTERIDLE"
    msgList(&H122) = "WM_MENURBUTTONUP"
    msgList(&H123) = "WM_MENUDRAG"
    msgList(&H124) = "WM_MENUGETOBJECT"
    msgList(&H125) = "WM_UNINITMENUPOPUP"
    msgList(&H126) = "WM_MENUCOMMAND"
    msgList(&H127) = "WM_CHANGEUISTATE"
    msgList(&H128) = "WM_UPDATEUISTATE"
    msgList(&H129) = "WM_QUERYUISTATE"
    msgList(&H132) = "WM_CTLCOLORMSGBOX"
    msgList(&H133) = "WM_CTLCOLOREDIT"
    msgList(&H134) = "WM_CTLCOLORLISTBOX"
    msgList(&H135) = "WM_CTLCOLORBTN"
    msgList(&H136) = "WM_CTLCOLORDLG"
    msgList(&H137) = "WM_CTLCOLORSCROLLBAR"
    msgList(&H138) = "WM_CTLCOLORSTATIC"
    msgList(&H200) = "WM_MOUSEMOVE"
    msgList(&H201) = "WM_LBUTTONDOWN"
    msgList(&H202) = "WM_LBUTTONUP"
    msgList(&H203) = "WM_LBUTTONDBLCLK"
    msgList(&H204) = "WM_RBUTTONDOWN"
    msgList(&H205) = "WM_RBUTTONUP"
    msgList(&H206) = "WM_RBUTTONDBLCLK"
    msgList(&H207) = "WM_MBUTTONDOWN"
    msgList(&H208) = "WM_MBUTTONUP"
    msgList(&H209) = "WM_MBUTTONDBLCLK"
    msgList(&H20A) = "WM_MOUSEWHEEL"
    msgList(&H20B) = "WM_XBUTTONDOWN"
    msgList(&H20C) = "WM_XBUTTONUP"
    msgList(&H20D) = "WM_XBUTTONDBLCLK"
    msgList(&H210) = "WM_PARENTNOTIFY"
    msgList(&H211) = "WM_ENTERMENULOOP"
    msgList(&H212) = "WM_EXITMENULOOP"
    msgList(&H213) = "WM_NEXTMENU"
    msgList(&H214) = "WM_SIZING"
    msgList(&H215) = "WM_CAPTURECHANGED"
    msgList(&H216) = "WM_MOVING"
    msgList(&H218) = "WM_POWERBROADCAST"
    msgList(&H219) = "WM_DEVICECHANGE"
    msgList(&H220) = "WM_MDICREATE"
    msgList(&H221) = "WM_MDIDESTROY"
    msgList(&H222) = "WM_MDIACTIVATE"
    msgList(&H223) = "WM_MDIRESTORE"
    msgList(&H224) = "WM_MDINEXT"
    msgList(&H225) = "WM_MDIMAXIMIZE"
    msgList(&H226) = "WM_MDITILE"
    msgList(&H227) = "WM_MDICASCADE"
    msgList(&H228) = "WM_MDIICONARRANGE"
    msgList(&H229) = "WM_MDIGETACTIVE"
    msgList(&H230) = "WM_MDISETMENU"
    msgList(&H231) = "WM_ENTERSIZEMOVE"
    msgList(&H232) = "WM_EXITSIZEMOVE"
    msgList(&H233) = "WM_DROPFILES"
    msgList(&H234) = "WM_MDIREFRESHMENU"
    msgList(&H280) = "WM_IME_REPORT"
    msgList(&H281) = "WM_IME_SETCONTEXT"
    msgList(&H282) = "WM_IME_NOTIFY"
    msgList(&H283) = "WM_IME_CONTROL"
    msgList(&H284) = "WM_IME_COMPOSITIONFULL"
    msgList(&H285) = "WM_IME_SELECT"
    msgList(&H286) = "WM_IME_CHAR"
    msgList(&H288) = "WM_IME_REQUEST"
    msgList(&H290) = "WM_IME_KEYDOWN"
    msgList(&H291) = "WM_IME_KEYUP"
    msgList(&H2A0) = "WM_NCMOUSEHOVER"
    msgList(&H2A1) = "WM_MOUSEHOVER"
    msgList(&H2A2) = "WM_NCMOUSELEAVE"
    msgList(&H2A3) = "WM_MOUSELEAVE"
    msgList(&H300) = "WM_CUT"
    msgList(&H301) = "WM_COPY"
    msgList(&H302) = "WM_PASTE"
    msgList(&H303) = "WM_CLEAR"
    msgList(&H304) = "WM_UNDO"
    msgList(&H305) = "WM_RENDERFORMAT"
    msgList(&H306) = "WM_RENDERALLFORMATS"
    msgList(&H307) = "WM_DESTROYCLIPBOARD"
    msgList(&H308) = "WM_DRAWCLIPBOARD"
    msgList(&H309) = "WM_PAINTCLIPBOARD"
    msgList(&H30A) = "WM_VSCROLLCLIPBOARD"
    msgList(&H30B) = "WM_SIZECLIPBOARD"
    msgList(&H30C) = "WM_ASKCBFORMATNAME"
    msgList(&H30D) = "WM_CHANGECBCHAIN"
    msgList(&H30E) = "WM_HSCROLLCLIPBOARD"
    msgList(&H30F) = "WM_QUERYNEWPALETTE"
    msgList(&H310) = "WM_PALETTEISCHANGING"
    msgList(&H311) = "WM_PALETTECHANGED"
    msgList(&H312) = "WM_HOTKEY"
    msgList(&H317) = "WM_PRINT"
    msgList(&H318) = "WM_PRINTCLIENT"
    msgList(&H319) = "WM_APPCOMMAND"
    msgList(&H358) = "WM_HANDHELDFIRST"
    msgList(&H35F) = "WM_HANDHELDLAST"
    msgList(&H360) = "WM_AFXFIRST"
    msgList(&H37F) = "WM_AFXLAST"
    msgList(&H380) = "WM_PENWINFIRST"
    msgList(&H381) = "WM_RCRESULT"
    msgList(&H382) = "WM_HOOKRCRESULT"
    msgList(&H383) = "WM_GLOBALRCCHANGE"
    msgList(&H384) = "WM_SKB"
    msgList(&H385) = "WM_PENCTL"
    msgList(&H386) = "WM_PENMISC"
    msgList(&H387) = "WM_CTLINIT"
    msgList(&H388) = "WM_PENEVENT"
    msgList(&H38F) = "WM_PENWINLAST"
End Sub
